package org.drools.reteoo.model;

import java.io.Serializable;

/**
 * Sample event used in the tests.
 */
public class TestEvent implements Serializable {

    private static final long serialVersionUID = -6985691286327371275L;

    private final Integer id;
    private final String name;
    private Serializable value;

    public TestEvent(Integer id, String name, Serializable value) {
        this.id = id;
        this.name = name;
        this.value = value;
    }

    public int getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public Serializable getValue() {
        return value;
    }

    public void setValue(Serializable value) {
        this.value = value;
    }

    @Override
    public String toString() {
        return String.format("TestEvent[id=%s, name=%s, value=%s]", id, name, value);
    }
}
