package org.drools.reteoo;

import org.junit.After;
import org.junit.Before;

import org.junit.Test;
import org.kie.api.KieServices;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.rule.FactHandle;

/**
 *
 * Activation of rule creates Activation fact which can be used to control other rules.
 */
public class DeclarativeAgendaTest {

    private KieSession ksession;
    
    @Before
    public void prepareKieSession() throws Exception {
        KieServices ks = KieServices.Factory.get();
        ksession = ks.getKieClasspathContainer().newKieSession("agendaKSession");
    }

    @After
    public void disposeSession() {
        if (ksession != null) {
            ksession.dispose();
        }
    }
    
    @Test(timeout = 60000L)
    public void testActivationBlock() {
        // first run
        ksession.insert("startAgenda");
        ksession.insert("fireRules");
        FactHandle fireBlockerRule = ksession.insert("fireBlockerRule");
        ksession.fireAllRules();

        // second run
        ksession.delete(fireBlockerRule);
        ksession.fireAllRules();
    }
}
